C* LIBPOL_VERSION  "@(#)dqx.h	1.3 98C01C16"  
C* Author: CISI C CESBIO C CNES
 
#ifndef _POLDER_DQX_
#define _POLDER_DQX_

C*  Definition of DQX bits classed by product  
C*-------------------------------------------- 

C*  LEVEL 1   
C*----------- 

#define B1_DIR				32768
#define B1_DQX_ATTITUD			0+B1_DIR
#define B1_DQX_CORREJEC			1+B1_DIR
#define B1_DQX_CORPOL_443NP		2+B1_DIR
#define B1_DQX_CORPOL_OTHER		3+B1_DIR
#define B1_DQX_PROXSAT_443P		4+B1_DIR
#define B1_DQX_PROXSAT_443NP_490_565	5+B1_DIR
#define B1_DQX_PROXSAT_670P		6+B1_DIR
#define B1_DQX_PROXSAT_763_A_910	7+B1_DIR
#define B1_DQX_PIXDEGRAD_443P		8+B1_DIR
#define B1_DQX_PIXDEGRAD_443NP_490_565	9+B1_DIR
#define B1_DQX_PIXDEGRAD_670P		10+B1_DIR
#define B1_DQX_PIXDEGRAD_763_A_910	11+B1_DIR
#define B1_DQX_PARASIT_FIRST_TYPE_1	12+B1_DIR
#define B1_DQX_PARASIT_FIRST_TYPE_2	13+B1_DIR
#define B1_DQX_PARASIT_SND_TYPE_1	14+B1_DIR
#define B1_DQX_PARASIT_SND_TYPE_2	15+B1_DIR

C*  LEVEL 2   
C*  Land Surfaces & Atmosphere: surface parameters   
C*-------------------------------------------------- 

#define L2_DQX_670_865		0
#define L2_DQX_763_765		1
#define L2_DQX_865_910		2
#define L2_DQX_NSD		3
#define L2_DQX_VIEW		4
#define L2_DQX_CENTRAL		5
#define L2_DQX_FOREST		6
#define L2_DQX_SNOW		7
#define L2_DQX_O3		8+2*256
#define L2_DQX_ST1		10
#define L2_DQX_ST2		11
#define L2_DQX_ID		12
#define L2_DQX_IDNLIM		13
#define L2_DQX_CLOUD4		14
#define L2_DQX_CLOUD2		15
#define L2_DQX_IN		16+8*256
#define L2_DQX_NPCLEAR		24+4*256
#define L2_DQX_33VIEW		28
#define L2_DQX_DHS		29+3*256
#define L2_DQX_IQ_AER		32+8*256
#define L2_DQX_ATR1		40
#define L2_DQX_ATR2		41
#define L2_DQX_ATR3		42
#define L2_DQX_ATR4		43
#define L2_DQX_BRDF_AER		48
#define L2_DQX_BRDF_MOD		49+2*256
#define L2_DQX_BRDF_ECART	51+5*256
#define L2_DQX_SN443		56
#define L2_DQX_SN670		57
#define L2_DQX_SN865		58
#define L2_DQX_RSURF		60+4*256

C*  LEVEL 2   
C*  Land Surfaces & Atmosphere: aerosols and water vapor   
C*-------------------------------------------------------- 

#define L2_DQS_CLOUD		0
#define L2_DQS_NPCLEAR		1+4*256
#define L2_DQS_CENTRAL		5
#define L2_DQS_SNOW		6
#define L2_DQS_865_910		8
#define L2_DQS_QU_443		9
#define L2_DQS_QU_670		10
#define L2_DQS_QU_865		11
#define L2_DQS_O3		12+2*256
#define L2_DQS_ST1		14
#define L2_DQS_ST2		15
#define L2_DQS_ATR1		16
#define L2_DQS_ATR2		17
#define L2_DQS_ATR3		18
#define L2_DQS_ATR4		19
#define L2_DQS_ECARTS		20
#define L2_DQS_IDNLIM		21
#define L2_DQS_IQ_AER		24+8*256

C*  LEVEL 3   
C*  Land Surfaces & Atmosphere: surface directional signatures   
C*  Land Surfaces & Atmosphere: albedo and vegetation paramters  
C*-------------------------------------------------------------- 

#define L3_DQXR_filter_nb_tracks_out         	  0+ 8*256
#define L3_DQXR_process_pixel_tracks_in_decade    8+ 2*256
#define L3_DQXR_filter_type			 10+ 2*256
#define L3_DQXR_filter_nb_cloudy_tracks		 12+ 8*256
#define L3_DQXR_filter_stability		 20+ 2*256
#define L3_DQXR_filter_layer_type		 22+ 2*256
#define L3_DQXR_process_pixel_nb_tracks		 24+ 8*256
#define L3_DQXR_inv_brdf_rms_865         	 32+ 6*256
#define L3_DQXR_inv_brdf_rms_765         	 38+ 6*256
#define L3_DQXR_inv_brdf_rms_670         	 44+ 6*256
#define L3_DQXR_inv_brdf_rms_565         	 50+ 6*256
#define L3_DQXR_inv_brdf_rms_443         	 56+ 6*256
C*  2 bits inutilises #define L3_DQXR_pad2       62+ 2*256 
#define L3_DQXR_inv_brdf_r2_865         	 64+ 6*256
#define L3_DQXR_inv_brdf_r2_765         	 70+ 6*256
#define L3_DQXR_inv_brdf_r2_670         	 76+ 6*256
#define L3_DQXR_inv_brdf_r2_565         	 82+ 6*256
#define L3_DQXR_inv_brdf_r2_443         	 88+ 6*256
C*  2 bits inutilises #define L3_DQXR_pad3       94+ 2*256 
#define L3_DQXR_merge_median_is_mode         	 96+ 2*256
#define L3_DQXR_merge_nb_tracks_out         	 98+ 8*256
#define L3_DQXR_merge_nb_tracks_in         	106+ 8*256
C* 14 bits inutilises #define L3_DQXR_pad4      114+14*256 




C*  LEVEL 3   
C*  Land Surfaces & Atmosphere: atmospheric parameters  
C*----------------------------------------------------- 

#define L3_DQS_NAER	0
#define L3_DQS_DECADE	2

C*  LEVEL 2   
C*  Ocean color & marine aerosols: directional parameters   
C*  and   
C*  Ocean color & marine aerosols: non directional parameters   
C*------------------------------------------------------------- 

#define O2_DQX_O2		0
#define O2_DQX_TH2O		1
#define O2_DQX_TO2		2
#define O2_DQX_INV_PIX_N3	3
#define O2_DQX_MAR_PARAM	4
#define O2_DQX_PIG_565		5
#define O2_DQX_PIG_490		6
#define O2_DQX_PIGNDPI_443	7
#define O2_DQX_IT_AERO		8
#define O2_DQX_IT_865		9
#define O2_DQX_IT_443		10
#define O2_DQX_RA865		11
#define O2_DQX_EXT_TAU		12
#define O2_DQX_NOBS		13
#define O2_DQX_TETAV		14
#define O2_DQX_COR_AERO		20
#define O2_DQX_EXT_AERO		21
#define O2_DQX_ISOL_PIX		22
#define O2_DQX_U_COX_MUNK	23
#define O2_DQX_CLOUD1		24
#define O2_DQX_CLOUD2		25
#define O2_DQX_CLOUD4		26
#define O2_DQX_ORIG_OZON	27
#define O2_DQX_CLOUD3		28
#define O2_DQX_U		29+2*256

C*  LEVEL 2   
C*  Ocean color & marine aerosols: marine aerosol parameters   
C*------------------------------------------------------------ 

#define O2_DQS_O2		0
#define O2_DQS_TH2O		1
#define O2_DQS_TO2		2
#define O2_DQS_INV_PIX_N3       3
#define O2_DQS_TAU		4
#define O2_DQS_TAU_MF		5
#define O2_DQS_TAU_ALGO		6
#define O2_DQS_CAS1		7
#define O2_DQS_CAS2		8
#define O2_DQS_CAS3		9
#define O2_DQS_CAS4		10
#define O2_DQS_PHI		11
#define O2_DQS_COR_AERO         20
#define O2_DQS_EXT_AERO         21
#define O2_DQS_COR_PRESS	22
#define O2_DQS_CLOUD3		23
#define O2_DQS_CLOUD1		24
#define O2_DQS_CLOUD2		25
#define O2_DQS_CLOUD4		26
#define O2_DQS_ORIG_OZON	27
#define O2_DQS_MIXT_O2		28
#define O2_DQS_U		29+2*256
#define O2_DQS_U_NOT_HOMOG	31

C*  LEVEL 3   
C*  Ocean color & marine aerosols: marine parameters synthesis  
C*------------------------------------------------------------- 

#define O3_DQX_NB_OF_OBSERV	0+9*256

C*  LEVEL 3   
C*  Ocean color & marine aerosols: marine aerosol parameters   
C*------------------------------------------------------------ 

#define O3_DQS_NB_OF_OBSERV	0+9*256

C*  LEVEL 2   
C*  Earth radiation and clouds  
C*----------------------------- 


#define R2_DQS_MOY_UH2O		0
#define R2_DQS_MOY_PCLOUD	1
#define R2_DQS_MOY_PRAY		2
#define R2_DQS_PHASE_LIQ	3
#define R2_DQS_PHASE_ICE	4
#define R2_DQS_PHASE_MIX	5
#define R2_DQS_TAU_CAL		6
#define R2_DQS_SNOW_ICE		7
#define R2_DQS_NOGLITTER	8
#define R2_DQS_CN_EQ_0		9
#define R2_DQS_CN_NEQ_0		10
#define R2_DQS_IQSURF1_EQ_0	11
#define R2_DQS_IQSURF2_EQ_0	12
#define R2_DQS_AVIS		13
#define R2_DQS_ASW		14



C*  LEVEL 3   
C*  Earth radiation and clouds  
C*----------------------------- 
C* not used  
#endif
