//
// C++ Implementation: observation
//
// Description: represents a satellite observation : a viewed earth pixel and the viewing direction
//
//
// Author: Nicolas PASCAL <nicolas.pascal@icare.univ-lille1.fr, (C) 2012
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include "observation.h"

Observation::Observation(const float lat, const float lon, const float alt, const double time,
    const vector <int> & idata, const vector <int> & igrid,
    const Carthesian::Segment3D & viewing) {
    set (lat, lon, alt, time, idata, igrid, viewing);
}
Observation::Observation(const Observation & obj) {
    set (obj.lat, obj.lon, obj.alt, obj.time, obj.idata, obj.igrid, obj.viewing);
}
Observation & Observation::operator =(const Observation & obj) {
    if (this != &obj)
        set (obj.lat, obj.lon, obj.alt, obj.time, obj.idata, obj.igrid, obj.viewing);
    return *this;
}
void Observation::set(const float lat, const float lon, const float alt, const double time,
    const vector <int> & idata, const vector <int> & igrid,
    const Carthesian::Segment3D & viewing) {
    this->lat = lat;
    this->lon = lon;
    this->alt = alt;
    this->time = time;
    this->idata = idata;
    this->igrid = igrid;
    this->viewing = viewing;
}
