/***************************************************************************
 *   Copyright (C) 2006 by Nicolas PASCAL   *
 *   pascal@icare-pc12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "ceresfiledata.h"

int main(int argc, char *argv[]) {

    string fname("/home/pascal/DATA/CERES/CRS/2004/2004_01_01/CER_CRS_Aqua-FM4-MODIS_Beta1_018025.2004010100");
    CERESFileData cfd(fname);
    Date d;

    /* print out some informations read in the filename */
    cout<<"Radix "<<cfd.get_radix()<<endl;
    cout<<"Product "<<cfd.get_product()<<endl;
    cout<<"Platform "<<cfd.get_platform()<<endl;
    cout<<"Instrument "<<cfd.get_instrument()<<endl;
    cout<<"Version "<<cfd.get_version()<<endl;
    cout<<"Date "<<cfd.get_date()<<endl;
    cout<<"Nb geo points "<<cfd.get_nb_geo_points()<<endl;

    /* search for coincidences */
    float lat;
    float lon;
    int index;

    cfd.load_geolocation_data();

    lat=-3.495;
    lon=12.031;
    if (cfd.get_index(lat,lon,-1.,index)) // should be 0
        cout<<"Coincidence to ("<<lat<<","<<lon<<") found at index "<<index<<endl;
    else
        cout<<"Coincidence not found"<<endl;

    lat=-52.1053;
    lon=-154.9624;
    if (cfd.get_index(lat,lon,-1.,index)) // should be 55319
        cout<<"Coincidence to ("<<lat<<","<<lon<<") found at index "<<index<<endl;
    else
        cout<<"Coincidence not found"<<endl;

    lat=21.6541;
    lon=177.9699;
    if (cfd.get_index(lat,lon,-1.,index)) // should be 89565
        cout<<"Coincidence to ("<<lat<<","<<lon<<") found at index "<<index<<endl;
    else
        cout<<"Coincidence not found"<<endl;

    lat=41.7253;
    lon=174.8615;
    if (cfd.get_index(lat,lon,-1.,index)) // should be 98460
        cout<<"Coincidence to ("<<lat<<","<<lon<<") found at index "<<index<<endl;
    else
        cout<<"Coincidence not found"<<endl;

    cfd.free_geolocation_data();

    return 0;
}
