/***************************************************************************
 *   Copyright (C) 2006 by Nicolas PASCAL   *
 *   pascal@icare-pc12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "cloudsatfiledata.h"

int main(int argc, char *argv[]) {
    string fname("/DATA/CLOUDSAT/2B-TAU/2009/2009_01_01/2009001035423_14254_CS_2B-TAU_GRANULE_P_R04_E02.hdf");
    CLOUDSATFileData cfd(fname);
    /* print out some informations read in the filename */
    cout<<"Product "<<cfd.get_product()<<endl;
    cout<<"Version "<<cfd.get_version()<<endl;
    cout<<"Date "; cfd.get_date().print(); cout<<endl;

    printf("Pixel set size [%d]\n", cfd.get_nb_geo_points() );

    Hdf_file * hdf_file = cfd.get_hdf_file();
//     char   c_buf [ 256 ];
    double scale_factor     = 0.;
    double scale_factor_err = 0.;
    double scale_offset     = 0.;
    double scale_offset_err = 0.;
    int32 type_id           = -1;
//     hdf_file -> get_calibration(    "Radar_Reflectivity",
//                                     scale_factor, scale_factor_err,
//                                     scale_offset, scale_offset_err,
//                                     type_id );


    /* read some data */
    cfd.load_geolocation_data();

    /* search for a coincidence */
    float lat, lon;
    int ipix;
    lat = -61.879589; lon = -51.712971; // Should be found
    if (cfd.get_index(lat,lon,ipix, 0.5)) // coincidence found
        cout<<"Coincidence to ("<<lat<<","<<lon<<") : Found at index ["<<ipix<<"]"<<endl;
    else // coincidence not found
        cout<<"Coincidence to ("<<lat<<","<<lon<<") : NOT found. idx= ["<<ipix<<"]"<<endl;


// // // //     /* read some data */
// // // //     cfd.load_geolocation_data();
// // // //
// // // //     /* search for a coincidence */
// // // //     float lat;
// // // //     float lon;
// // // //     int idx;
// // // //
// // // //     lat=0.025756009;lon=12.108582; // Should not be found
// // // //     if (cfd.get_index(lat,lon,idx)) // coincidence found
// // // //         cout<<"Coincidence to ("<<lat<<","<<lon<<") : Found at index ["<<idx<<"]"<<endl;
// // // //     else // coincidence not found
// // // //         cout<<"Coincidence to ("<<lat<<","<<lon<<") : NOT found. idx= ["<<idx<<"]"<<endl;
// // // //
// // // //     lat=0.025756009;lon=16.108582; // Should be found at 0
// // // //     if (cfd.get_index(lat,lon,idx)) // coincidence found
// // // //         cout<<"Coincidence to ("<<lat<<","<<lon<<") : Found at index ["<<idx<<"]"<<endl;
// // // //     else // coincidence not found
// // // //         cout<<"Coincidence to ("<<lat<<","<<lon<<") : NOT found. idx= ["<<idx<<"]"<<endl;
// // // //
// // // //     lat=-5.8031077;lon=14.86561; // Should be found at 604
// // // //     if (cfd.get_index(lat,lon,idx)) // coincidence found
// // // //         cout<<"Coincidence to ("<<lat<<","<<lon<<") : Found at index ["<<idx<<"]"<<endl;
// // // //     else // coincidence not found
// // // //         cout<<"Coincidence to ("<<lat<<","<<lon<<") : NOT found. idx= ["<<idx<<"]"<<endl;
// // // //
// // // //     lat=-0.015792368;lon=-8.621794; // Should be found at 37086
// // // //     if (cfd.get_index(lat,lon,idx)) // coincidence found
// // // //         cout<<"Coincidence to ("<<lat<<","<<lon<<") : Found at index ["<<idx<<"]"<<endl;
// // // //     else // coincidence not found
// // // //         cout<<"Coincidence to ("<<lat<<","<<lon<<") : NOT found. idx= ["<<idx<<"]"<<endl;
// // // // //
// // // // //     lat=58.97;lon=75.96; // Should be found at [6059,1]
// // // // //     if (cfd.get_index(lat,lon,idx)) // coincidence found
// // // // //         cout<<"Coincidence to ("<<lat<<","<<lon<<") : Found at index ["<<idx<<"]"<<endl;
// // // // //     else // coincidence not found
// // // // //         cout<<"Coincidence to ("<<lat<<","<<lon<<") : NOT found. idx= ["<<idx<<"]"<<endl;
// // // // //     //Bench(cfd.get_index(lat,lon,idx));




    return 0;

}
