/***************************************************************************
 *   Copyright (C) 2011 by Nicolas PASCAL   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "dardarfiledata.h"

int main(int argc, char *argv[]) {
    string fname("/DATA/MULTI_SENSOR/DARDAR_MASK/2009/2009_01_01/DARDAR-MASK_v1.1.2_2009001035423_14254.hdf");
//     string fname("/DATA/MULTI_SENSOR/DARDAR_CLOUD/2010/2010_01_17/DARDAR-CLOUD_v2.1.0_2010017081916_19805.hdf");
    DARDARFileData cfd(fname);
    /* print out some informations read in the filename */
    cout<<"Product "<<cfd.get_product()<<endl;
    cout<<"Version "<<cfd.get_version()<<endl;
    cout<<"Date "; cfd.get_date().print(); cout<<endl;

    printf("Pixel set size [%d]\n", cfd.get_nb_geo_points() );
    float lat, lon;
    int ipix;
    double time;
    for (ipix = 0 ; ipix < 10 ; ++ipix) {
        cfd.get_pixel_coord (ipix, lat, lon, time);
        printf ( "ipix=%d -> pos = (%f, %f) ts = %.12f\n", ipix, lat, lon, time );
    }

    /* read some data */
    cfd.load_geolocation_data();

    /* search for a coincidence */
    lat = -61.879589; lon = -51.712971; // Should be found
    if (cfd.get_index(lat,lon,ipix, 0.5)) // coincidence found
        cout<<"Coincidence to ("<<lat<<","<<lon<<") : Found at index ["<<ipix<<"]"<<endl;
    else // coincidence not found
        cout<<"Coincidence to ("<<lat<<","<<lon<<") : NOT found. idx= ["<<ipix<<"]"<<endl;



    return 0;

}
