/***************************************************************************
 *   Copyright (C) 2006 by Nicolas PASCAL   *
 *   pascal@icare-pc12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/**
 * @file test_date.cpp do some unit tests on the date.h module
 * history :
 *   14/06/2006 : creation
 */

#include "date.h"

int main(int argc, char *argv[]) {
    Date d,d1,d2;
    double leap_sec;
    char format[] = "%Y-%m-%dT%H:%M:%S";
    /********** check the string formatting methods **********/

    // set a date from a formatted string
    d1.set_date_str("2007-06-14T16:27:33", format);
    // get a date as a formatted string
    cout<<d1.get_date_str("%c")<<endl;

    // get a days list between 2 dates
    d1.set_date_str("2006-12-29T00:00:00", format); // start date
    d2.set_date_str("2007-01-12T00:00:00", format); // end date
    vector<Date> day_list=Date::get_days(d1,d2);
    cout<<"--- days in range "<<d1<<"->"<<d2<<" ---"<<endl;
    for (vector<Date>::iterator i=day_list.begin();i!=day_list.end();++i)
        cout<<*i<<", ";
    cout<<endl;

    // leap seconds management
    const char * v_date[] = { "1983-02-01T00:00:00",
                              "1992-07-01T00:00:00",
                              "2011-12-29T00:00:00",
                              "1970-01-01T00:00:00",
                            };
    int sz_v_date = sizeof (v_date) / sizeof (char*);
    for ( int i = 0 ; i < sz_v_date ; ++i ) {
        d.set_date_str(v_date[i], format);
        leap_sec = Date::get_tai93_leap_sec ( d );
        cout << "Date = " << d << " leap = " << leap_sec << endl;
    }

    cout<<endl;
    return 0;
}



