/***************************************************************************
 *   Copyright (C) 2006 by Nicolas PASCAL   *
 *   pascal@icare-pc12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "modisfiledata.h"

int main(int argc, char *argv[]) {
//      MODISFileData fd("/home/pascal/DATA/LIENS/MODIS/MYD021KM/2006/2006_12_28/MYD021KM.A2006362.0000.005.2006363172729.hdf");
//      MODISFileData fd("/DATA/LIENS/MODIS/MYD05_L2/2007/2007_03_01/MYD05_L2.A2007060.0050.005.2007068205433.hdf");
     MODISFileData fd("/DATA/LIENS/MODIS/MYD03/2009/2009_01_01/MYD03.A2009001.0000.005.2009330051638.hdf");


    /* print out some informations */
    cout<<"Product "<<fd.get_product()<<endl;
    cout<<"Resolution "<<fd.get_resolution()<<endl;
    cout<<"Radix "<<fd.get_radix()<<endl;
    cout<<"Date "<<fd.get_date()<<endl;

    /* coincidence search */
    int idx[]={-1,-1};
//     int idx_5km[]={-1,-1};
    float lat;
    float lon;


    /* --- MYD03 --- */

    fd.load_geolocation_data();

    cout<<"-------------------------------------"<<endl;
    lat = 54.948025; // should be exact -> (787,842)
    lon = -170.42566;
    if ( fd.get_index ( lat, lon, -1., idx ) )
        printf ( "(%f,%f) -> [%d,%d]\n", lat, lon, idx[0], idx[1] );

    fd.free_geolocation_data();

    /* --- MYD021KM --- */

//     fd.load_geolocation_data();
//     cout<<"-------------------------------------"<<endl;
//     lat = -3.1707826; // should be exact -> (0,0)
//     lon = 12.0974045;
//     if (fd.get_index(lat,lon,-1.,idx))
//         cout<<"("<<lat<<","<<lon<<")"<<" found at ("<<idx[0]<<","<<idx[1]<<")"<<endl;
//     cout<<"-------------------------------------"<<endl;
//     lat = -6.149877; // should be exact -> (0,269)
//     lon = 32.527287;
//     if (fd.get_index(lat,lon,-1.,idx))
//         cout<<"("<<lat<<","<<lon<<")"<<" found at ("<<idx[0]<<","<<idx[1]<<")"<<endl;
//     cout<<"-------------------------------------"<<endl;
//     lat = -24.061823; // should be exact -> (405,269)
//     lon = 29.480896;
//     if (fd.get_index(lat,lon,-1.,idx))
//         cout<<"("<<lat<<","<<lon<<")"<<" found at ("<<idx[0]<<","<<idx[1]<<")"<<endl;
//     cout<<"-------------------------------------"<<endl;
//     lat = -20.820648; // should be exact -> (405,0)
//     lon = 7.288439;
//     if (fd.get_index(lat,lon,-1.,idx))
//         cout<<"("<<lat<<","<<lon<<")"<<" found at ("<<idx[0]<<","<<idx[1]<<")"<<endl;
//     cout<<"-------------------------------------"<<endl;
//     lat = -19.887342; // should be exact -> (180,332)
//     lon = 21.352146;
//     if ( fd.get_index(lat,lon,-1.,idx) )
//         cout<<"("<<lat<<","<<lon<<")"<<" found at ("<<idx[0]<<","<<idx[1]<<")"<<endl;

//     cout<<"-------------------------------------"<<endl;
//     lat=-69.645; lon=-93.253;
//     fd.get_index(lat,lon,1.,idx_5km,0.05); // outside of the file
//     cout<<"Point ("<<lat<<","<<lon<<") -> 5km ("<<idx_5km[0]<<","<<idx_5km[1]<<")"<<endl;

//     cout<<"-------------------------------------"<<endl;
//     lat=-69.645; lon=-93.253;
// //     idx_5km[0]=299,idx_5km[1]=3;
//     fd.get_5_to_1km_index(lat,lon,idx,idx_5km); // outside of the file
//     cout<<"Point ("<<lat<<","<<lon<<") 5km ("<<idx_5km[0]<<","<<idx_5km[1]<<") 1km ("<<idx[0]<<","<<idx[1]<<")"<<endl;

//     cout<<"-------------------------------------"<<endl;
//     fd.get_5_to_1km_index(-20.303448,7.450786,idx); // middle of the cell (394,0) -> should be (1972,2)
//     cout<<"5km to 1km indexes : ("<<idx[0]<<","<<idx[1]<<")"<<endl;



//     fd.free_geolocation_data();

//     cout<<"-------------------------------------"<<endl;
//     int five_km_idx[]={0,0};
//     int min_1km_idx[2];
//     int max_1km_idx[2];
//     MODISFileData::get_5_to_1km_area(five_km_idx,min_1km_idx,max_1km_idx);
//     cout<<"5km Cell ("<<five_km_idx[0]<<","<<five_km_idx[1]<<") overlap 1km Cells ("<<min_1km_idx[0]<<","<<min_1km_idx[1]<<") -> ("<<max_1km_idx[0]<<","<<max_1km_idx[1]<<")"<<endl;
//
//     cout<<"-------------------------------------"<<endl;
//     five_km_idx[0]=1;
//     five_km_idx[1]=1;
//     MODISFileData::get_5_to_1km_area(five_km_idx,min_1km_idx,max_1km_idx);
//     cout<<"5km Cell ("<<five_km_idx[0]<<","<<five_km_idx[1]<<") overlap 1km Cells ("<<min_1km_idx[0]<<","<<min_1km_idx[1]<<") -> ("<<max_1km_idx[0]<<","<<max_1km_idx[1]<<")"<<endl;
//
//     cout<<"-------------------------------------"<<endl;
//     five_km_idx[0]=405;
//     five_km_idx[1]=270;
//     MODISFileData::get_5_to_1km_area(five_km_idx,min_1km_idx,max_1km_idx);
//     cout<<"5km Cell ("<<five_km_idx[0]<<","<<five_km_idx[1]<<") overlap 1km Cells ("<<min_1km_idx[0]<<","<<min_1km_idx[1]<<") -> ("<<max_1km_idx[0]<<","<<max_1km_idx[1]<<")"<<endl;
//
//     cout<<"-------------------------------------"<<endl;
//     lat=-24.;
//     lon=-7.;
//     cout<<"("<<lat<<","<<lon<<") is inside "<<fd.get_name()<<"? "<<fd.contain_location(lat,lon)<<endl;
//
//     cout<<"-------------------------------------"<<endl;
//     lat=-4.;
//     lon=13.;
//     cout<<"("<<lat<<","<<lon<<") is inside "<<fd.get_name()<<"? "<<fd.contain_location(lat,lon)<<endl;
//
//     /* specific functioning modes */
//     cout<<"-------------------------------------"<<endl;
//     MODISFileData fd2("/home/pascal/LINKS/ONE_MONTH/MODIS/MYD06_L2/MYD06_L2.A2004001.0005.004.2004077230246.hdf");
//     int prev_idx[]={-1,-1};
//
//     lat=-31.3129;
//     lon=3.2647;
//     if (fd2.get_index(lat,lon,-1.,idx,0.1)) {
//         cout<<"("<<lat<<","<<lon<<")"<<" found at ("<<idx[0]<<","<<idx[1]<<")"<<endl;
//         prev_idx[0]=idx[0];
//         prev_idx[1]=idx[1];
//     } else
//         cout<<"("<<lat<<","<<lon<<")"<<" not found"<<endl;
//
//     // search the next point using the 'search near point'
//     lat=-31.3577;
//     lon=3.225291;
//     if (fd2.get_index(lat,lon,-1.,idx,0.1)) {
//         cout<<"("<<lat<<","<<lon<<")"<<" found at ("<<idx[0]<<","<<idx[1]<<")"<<endl;
//         prev_idx[0]=idx[0];
//         prev_idx[1]=idx[1];
//     } else
//         cout<<"("<<lat<<","<<lon<<")"<<" not found"<<endl;
//
//
//     /* test coincidence search near changing date longitude */
//     cout<<"-------------------------------------"<<endl;
//     MODISFileData fd3("/home/pascal/LINKS/ONE_MONTH/MODIS/MYD06_L2/MYD06_L2.A2004001.0100.004.2004077233334.hdf");
//
//     fd3.print_gring();
//
//     lat=49.;
//     lon=157.;
//     if (fd3.get_index(lat,lon,-1.,idx)) {
//         cout<<"("<<lat<<","<<lon<<")"<<" found at ("<<idx[0]<<","<<idx[1]<<")"<<endl;
//     } else
//         cout<<"("<<lat<<","<<lon<<")"<<" not found"<<endl;
//
//     lat=52.;
//     lon=-170.;
//     if (fd3.get_index(lat,lon,-1.,idx)) {
//         cout<<"("<<lat<<","<<lon<<")"<<" found at ("<<idx[0]<<","<<idx[1]<<")"<<endl;
//     } else
//         cout<<"("<<lat<<","<<lon<<")"<<" not found"<<endl;

  /* Test GRing extraction */


    return 0;
}
