/***************************************************************************
 *   Copyright (C) 2009 by Nicolas PASCAL   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "modisfiledata.h"

int main(int argc, char *argv[]) {
    int i_pix_250m [2], i_pix_1km [2];
    fill_n ( i_pix_250m, 2, -1 );
    fill_n ( i_pix_1km, 2, -1 );

    float32 lat, lon, lat_250m, lon_250m;

    MODISFileData fd ( "/DATA/LIENS/MODIS/MYD02QKM/2009/2009_01_01/MYD02QKM.A2009001.0420.005.2009003202942.hdf" );

    /* print out some informations */
    cout<<"Product "<<fd.get_product()<<endl;
    cout<<"Resolution "<<fd.get_resolution()<<endl;
    cout<<"Radix "<<fd.get_radix()<<endl;
    cout<<"Date "<<fd.get_date()<<endl;

    fd.load_geolocation_data();

//     /* compute 250m pixels geolocation */
//     cout << "compute 250m pixels geolocation ..." << endl;
//     int sz_y_250m = fd.get_y_size_250m();
//     int sz_x_250m = fd.get_x_size_250m();
//     float32 * lat_data_250m = new float32 [ sz_y_250m * sz_x_250m ];
//     float32 * lon_data_250m = new float32 [ sz_y_250m * sz_x_250m ];
//     int i_x, i_y, i_y_start;
//     for ( i_y = 0 ; i_y < sz_y_250m ; ++i_y )
//     {
//         if ( ( i_y % 500 ) == 0 )
//             cout << "Scan line " << i_y << "/" << sz_y_250m << endl;
//         i_y_start = i_y * sz_x_250m;
//         for ( i_x = 0 ; i_x < sz_x_250m ; ++i_x )
//         {
//             fd.get_250m_pix_pos(i_y, i_x, lat, lon );
//             lat_data_250m [ i_y_start + i_x ] = lat;
//             lon_data_250m [ i_y_start + i_x ] = lon;
//         }
//     }
//     cout << "... done" << endl;
//
//     dump geolocation buffers
//     cout << "Dump geolocation datasets ..." << endl;
//     FILE * pf;
//     pf = fopen ("/home/pascal/depot/modis_geolocation/lat_data_250m.dat","wb");
//     if ( pf != NULL )
//     {
//         fwrite ( lat_data_250m , sizeof ( float32 ) , ( sz_y_250m * sz_x_250m ) , pf );
//         fclose ( pf );
//     }
//     delete [] lat_data_250m, lat_data_250m = NULL;
//
//     pf = fopen ("/home/pascal/depot/modis_geolocation/lon_data_250m.dat","wb");
//     if ( pf != NULL )
//     {
//         fwrite ( lon_data_250m , sizeof ( float32 ) , ( sz_y_250m * sz_x_250m ) , pf );
//         fclose ( pf );
//     }
//     delete [] lon_data_250m, lon_data_250m = NULL;
//     cout << "... done" << endl;

    /* test 1km pixel footprint search */
// // // //     int itk_1km, isc_1km, itk_250m_min, itk_250m_max, isc_250m_min, isc_250m_max;
// // // //     itk_1km = 0, isc_1km = 0;
// // // //     fd.get_bounds_1km_to_250m ( itk_1km, isc_1km, itk_250m_min, itk_250m_max, isc_250m_min, isc_250m_max );
// // // //     printf ( "ipix_1km = [%d, %d]\tipix_250m_min = [%d, %d]\tipix_250m_max = [%d, %d]\n",itk_1km, isc_1km, itk_250m_min, itk_250m_max, isc_250m_min, isc_250m_max );
// // // //
// // // //     itk_1km = 0, isc_1km = 1353;
// // // //     fd.get_bounds_1km_to_250m ( itk_1km, isc_1km, itk_250m_min, itk_250m_max, isc_250m_min, isc_250m_max );
// // // //     printf ( "ipix_1km = [%d, %d]\tipix_250m_min = [%d, %d]\tipix_250m_max = [%d, %d]\n",itk_1km, isc_1km, itk_250m_min, itk_250m_max, isc_250m_min, isc_250m_max );
// // // //
// // // //     itk_1km = 1, isc_1km = 1;
// // // //     fd.get_bounds_1km_to_250m ( itk_1km, isc_1km, itk_250m_min, itk_250m_max, isc_250m_min, isc_250m_max );
// // // //     printf ( "ipix_1km = [%d, %d]\tipix_250m_min = [%d, %d]\tipix_250m_max = [%d, %d]\n",itk_1km, isc_1km, itk_250m_min, itk_250m_max, isc_250m_min, isc_250m_max );
// // // //
// // // //     itk_1km = 9, isc_1km = 0;
// // // //     fd.get_bounds_1km_to_250m ( itk_1km, isc_1km, itk_250m_min, itk_250m_max, isc_250m_min, isc_250m_max );
// // // //     printf ( "ipix_1km = [%d, %d]\tipix_250m_min = [%d, %d]\tipix_250m_max = [%d, %d]\n",itk_1km, isc_1km, itk_250m_min, itk_250m_max, isc_250m_min, isc_250m_max );
// // // //
// // // //     itk_1km = 9, isc_1km = 1353;
// // // //     fd.get_bounds_1km_to_250m ( itk_1km, isc_1km, itk_250m_min, itk_250m_max, isc_250m_min, isc_250m_max );
// // // //     printf ( "ipix_1km = [%d, %d]\tipix_250m_min = [%d, %d]\tipix_250m_max = [%d, %d]\n",itk_1km, isc_1km, itk_250m_min, itk_250m_max, isc_250m_min, isc_250m_max );
// // // //
// // // //     itk_1km = 10, isc_1km = 0;
// // // //     fd.get_bounds_1km_to_250m ( itk_1km, isc_1km, itk_250m_min, itk_250m_max, isc_250m_min, isc_250m_max );
// // // //     printf ( "ipix_1km = [%d, %d]\tipix_250m_min = [%d, %d]\tipix_250m_max = [%d, %d]\n",itk_1km, isc_1km, itk_250m_min, itk_250m_max, isc_250m_min, isc_250m_max );

    /* coincidence search */
    // pixel out of granule
    lat = -72.49, lon = -50.06;
    fd.get_index ( lat, lon, -1., i_pix_1km, 0.1 );
    printf ( "P (%f,%f)\n i_1km [ %d,%d ]\n", lat, lon, i_pix_1km [0], i_pix_1km [1] );
    fd.get_1km_to_250m_pixel ( lat, lon, i_pix_1km, i_pix_250m );
    printf ( "i_250m [ %d,%d ]\n",i_pix_250m [0], i_pix_250m [1] );

    // pixel in granule
    lat = -73.91, lon = 170.53;
    fd.get_index ( lat, lon, -1., i_pix_1km, 0.1 );
    printf ( "P (%f,%f)\n i_1km [ %d,%d ]\n", lat, lon, i_pix_1km [0], i_pix_1km [1] );
    fd.get_1km_to_250m_pixel ( lat, lon, i_pix_1km, i_pix_250m );
    fd.get_250m_pix_pos ( i_pix_250m[0], i_pix_250m[1], lat_250m, lon_250m );
    printf ( "i_250m [ %d,%d ]\tcoord_250m (%f, %f)\tdist=%f\n",i_pix_250m [0], i_pix_250m [1], lat_250m, lon_250m, Geocentric::get_haversine_dist( lat, lon, lat_250m, lon_250m ) );

    // pixel in granule, near change date meridian
    lat = -61.5, lon = - 179.95;
    fd.get_index ( lat, lon, -1., i_pix_1km, 0.1 );
    printf ( "P (%f,%f)\n i_1km [ %d,%d ]\n", lat, lon, i_pix_1km [0], i_pix_1km [1] );
    fd.get_1km_to_250m_pixel ( lat, lon, i_pix_1km, i_pix_250m );
    fd.get_250m_pix_pos ( i_pix_250m[0], i_pix_250m[1], lat_250m, lon_250m );
    printf ( "i_250m [ %d,%d ]\tcoord_250m (%f, %f)\tdist=%f\n",i_pix_250m [0], i_pix_250m [1], lat_250m, lon_250m, Geocentric::get_haversine_dist( lat, lon, lat_250m, lon_250m ) );

    fd.free_geolocation_data();
    fflush ( stdout );

    return 0;
}
