/***************************************************************************
 *   Copyright (C) 2006 by Nicolas PASCAL   *
 *   pascal@icare-pc12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "parasolfiledata.h"

int main(int argc, char *argv[]) {
    unsigned short nb_bytes;
    double slope,offset;
    unsigned char *count_data=NULL;
//     unsigned short *ushort_count_data=NULL;
    double* scaled_data=NULL;
    string param,var;
    double val;

    bool show_val_display=true;
    string filename("/DATA/PARASOL/RB2/2009/2009_01_01/P3L2TRGB094003KL");
    PARASOLFileData pfd(filename);
    int nb_data=pfd.get_nb_data();

    // ***** test some attributes building *****
    cout<<"-------------------------------------------------------"<<endl;
    cout<<"Instrument "<<pfd.get_instrument()<<endl;
    cout<<"Level "<<pfd.get_level()<<endl;
    cout<<"Processing line "<<pfd.get_processing_line_string()<<endl;
    cout<<"Product "<<pfd.get_product()<<endl;
    cout<<"Orbit cycle number "<<pfd.get_orbit_cycle_nb()<<endl;
    cout<<"Orbit number "<<pfd.get_orbit_nb()<<endl;
    cout<<"Reprocessing number "<<pfd.get_reprocessing_nb()<<endl;
    cout<<"Radix "<<pfd.get_radix()<<endl;

    cout<<"Acquisition Start Time "<<pfd.get_date().to_string()<<endl;
    cout<<"Time coverage "<<pfd.get_time_coverage()<<endl;
    cout<<"Software Version Number "<<pfd.get_software_version_number()<<endl;
    cout<<"-------------------------------------------------------"<<endl;

    // ***** test scaling factors reading ****
    pfd.print_scaling_factors();

    // ***** test time methods ***** //
//     Date d;
//     d.set_date_str("2006:12:28T00:00:50","%Y:%m:%dT%H:%M:%S");
//     cout<<"Is "<<d.to_string()<<" in file ? "<<MyTools::to_string(pfd.contain_time(d.get_TAI93_time()))<<endl;
//     d.set_date_str("2006:12:28T00:00:40","%Y:%m:%dT%H:%M:%S");
//     cout<<"Is "<<d.to_string()<<" in file ? "<<MyTools::to_string(pfd.contain_time(d.get_TAI93_time()))<<endl;
//     d.set_date_str("2006:12:28T00:00:45","%Y:%m:%dT%H:%M:%S");
//     cout<<"Is "<<d.to_string()<<" in file ? "<<MyTools::to_string(pfd.contain_time(d.get_TAI93_time()))<<endl;
//     d.set_date_str("2006:12:28T00:45:00","%Y:%m:%dT%H:%M:%S");
//     cout<<"Is "<<d.to_string()<<" in file ? "<<MyTools::to_string(pfd.contain_time(d.get_TAI93_time()))<<endl;
//     d.set_date_str("2005:12:28T00:45:00","%Y:%m:%dT%H:%M:%S");
//     cout<<"Is "<<d.to_string()<<" in file ? "<<MyTools::to_string(pfd.contain_time(d.get_TAI93_time()))<<endl;
//     d.set_date_str("2006:12:28T00:43:00","%Y:%m:%dT%H:%M:%S");
//     cout<<"Is "<<d.to_string()<<" in file ? "<<MyTools::to_string(pfd.contain_time(d.get_TAI93_time()))<<endl;
//     // ***** test geolocation data reading *****
//     // init the geolocation data
//     pfd.load_geolocation_data();
//     unsigned short* lin=const_cast<unsigned short*>(pfd.get_line_data());
//     unsigned short* col=const_cast<unsigned short*>(pfd.get_col_data());
//     if (show_val_display) {
//         cout<<"line\tcolumn"<<endl;
//         for (int i = 0 ; i<nb_data ; ++i)
//             cout<<lin[i]<<"\t"<<col[i]<<endl;
//     }
//     cout<<"-------------------------------------------------------"<<endl;
//     // ***** test record index retrieval methods *****
//     float lat_lon[] = {0.,0.};
//     int pixel_coord[2];
//     int rec_idx;
//
//     // -> using pixel indexes
//     pixel_coord[0]=167;pixel_coord[1]=865; // first pixel
//     pfd.get_index(pixel_coord,rec_idx);
//     cout<<rec_idx<<endl; // should be 0 OK
//
//     pixel_coord[0]=992;pixel_coord[1]=1087; // normal pixel
//     pfd.get_index(pixel_coord,rec_idx);
//     cout<<rec_idx<<endl; // should be 48038 OK
//
//     pixel_coord[0]=1068;pixel_coord[1]=1092; // last pixel
//     pfd.get_index(pixel_coord,rec_idx);
//     cout<<rec_idx<<endl; // should be 54136 OK
//
//     // -> test lat_lon_to_grid methods
//     float lat_minmax[2];
//     float lon_minmax[2];
//
//     pixel_coord[0]=170;pixel_coord[1]=877;
//     pfd.grid_to_geolocation(pixel_coord,lat_minmax,lon_minmax);
//     cout<<"pixel ("<<pixel_coord[0]<<","<<pixel_coord[1]<<") -> lat ("<<lat_minmax[0]<<","<<lat_minmax[1]<<") ; lon("<<lon_minmax[0]<<","<<lon_minmax[1]<<")"<<endl;
//     // should be (61.75,-71.68)
//
//     lat_lon[0] = 58.;
//     lat_lon[1] = -78.;
//     pfd.geolocation_to_grid(lat_lon,pixel_coord);
//     cout<<"point ("<<lat_lon[0]<<","<<lat_lon[1]<<") -> pixel ("<<pixel_coord[0]<<","<<pixel_coord[1]<<")"<<endl;
//     // should be (192,833) OK
//
//     lat_lon[0] = -3.;
//     lat_lon[1] = -56.;
//     pfd.geolocation_to_grid(lat_lon,pixel_coord);
//     cout<<"point ("<<lat_lon[0]<<","<<lat_lon[1]<<") -> pixel ("<<pixel_coord[0]<<","<<pixel_coord[1]<<")"<<endl;
//     // should be (558,745) OK
//
//     lat_lon[0] = -84.;
//     lat_lon[1] = 59.;
//     pfd.geolocation_to_grid(lat_lon,pixel_coord);
//     cout<<"point ("<<lat_lon[0]<<","<<lat_lon[1]<<") -> pixel ("<<pixel_coord[0]<<","<<pixel_coord[1]<<")"<<endl;
//     // should be (1044,1118) OK
//
//     // -> using lat,lon coordinates
//     float lat,lon; // first pixel
//     lat = 0.;
//     lon=0.;
//     pfd.get_index(lat,lon,rec_idx);
//     cout<<rec_idx<<endl; // should be -1
//     cout<<"-------------------------------------------------------"<<endl;
//
    // ***** test param reading methods *****

    // -> Whole dataset

    param="pray"; // OK
    cout<<"---------- Extract Parameter "<<param<<" ----------"<<endl;
    pfd.get_scaling(param,slope,offset,nb_bytes);
    cout<<"Scale : "<<param<<" "<<nb_bytes<<" "<<slope<<" "<<offset<<endl;
    cout<<"---------------------------------------------------"<<endl;

    count_data=static_cast<unsigned char *>(pfd.read_count_data(count_data,param.c_str()));
    scaled_data=static_cast<double *>(pfd.read_scaled_data(scaled_data,param.c_str()));
    if (count_data!=NULL && scaled_data!=NULL) {
        if (show_val_display) {
            cout<<"Record\tCount\tScaled"<<endl;
            for (int i = 0 ; i<nb_data;++i) {
                cout<<i<<"\t"<<(int)count_data[i]<<"\t"<<scaled_data[i]<<endl;
            }
        }
    }
    delete[] count_data;
    count_data=NULL;
    delete[] scaled_data;
    scaled_data=NULL;

    // -> Subsetting
    int start[] = {67981};
    int edges[] = {1};
    pfd.read_data(&val,param.c_str(),start,NULL,edges);
    cout<<val<<endl; // FIXME

//     param="mus";
//     cout<<"---------- Extract Parameter "<<param<<" ----------"<<endl;
//     pfd.get_scaling(param,slope,offset,nb_bytes);
//     cout<<"Scale : "<<param<<" "<<nb_bytes<<" "<<slope<<" "<<offset<<endl;
//     cout<<"---------------------------------------------------"<<endl;
//     count_data=static_cast<unsigned char *>(pfd.read_count_data(count_data,param.c_str()));
//     scaled_data=static_cast<double *>(pfd.read_scaled_data(scaled_data,param.c_str()));
//     if (count_data!=NULL && scaled_data!=NULL) {
//         if (show_val_display) {
//             cout<<"Record\tCount\tScaled"<<endl;
//             for (int i = 0 ; i<nb_data;++i) {
//                 cout<<i<<"\t"<<(int)count_data[i]<<"\t"<<scaled_data[i]<<endl;
//             }
//         }
//     }
//     delete[] count_data;
//     count_data=NULL;
//     delete[] scaled_data;
//     scaled_data=NULL;
//

//     param="tau"; // OK
//     cout<<"---------- Extract Parameter "<<param<<" ----------"<<endl;
//     pfd.get_scaling(param,slope,offset,nb_bytes);
//     cout<<"Scale : "<<param<<" "<<nb_bytes<<" "<<slope<<" "<<offset<<endl;
//     cout<<"---------------------------------------------------"<<endl;
//     ushort_count_data=static_cast<unsigned short *>(pfd.read_count_data(ushort_count_data,param.c_str()));
//     scaled_data=static_cast<double *>(pfd.read_scaled_data(scaled_data,param.c_str()));
//     if (ushort_count_data!=NULL && scaled_data!=NULL) {
//         if (show_val_display) {
//             cout<<"Record\tCount\tScaled"<<endl;
//             for (int i = 0 ; i<nb_data;++i) {
//                 cout<<i<<"\t"<<ushort_count_data[i]<<"\t"<<scaled_data[i]<<endl;
//             }
//         }
//     }
//     delete[] ushort_count_data;
//     ushort_count_data=NULL;
//     delete[] scaled_data;
//     scaled_data=NULL;

//     int start[]={-1};
//     int edges[]={1};
//     param="tau"; // OK
//     cout<<"---------- Extract Parameter "<<param<<" ----------"<<endl;
//     for (int rec_idx=60000;rec_idx<65000;++rec_idx) {
//       start[0]=rec_idx;
//       pfd.read_data(&val,param.c_str(),start,NULL,edges,1);
//       cout<<"record "<<rec_idx<<" "<<val<<endl;
//     }

//     param="cc_dir"; // OK
//     cout<<"---------- Extract Parameter "<<param<<" ----------"<<endl;
//     pfd.get_scaling(param,slope,offset,nb_bytes);
//     cout<<"Scale : "<<param<<" "<<nb_bytes<<" "<<slope<<" "<<offset<<endl;
//     cout<<"---------------------------------------------------"<<endl;
//     count_data=static_cast<unsigned char *>(pfd.read_count_data(count_data,param.c_str()));
//     scaled_data=static_cast<double *>(pfd.read_scaled_data(scaled_data,param.c_str()));
//     if (count_data!=NULL && scaled_data!=NULL) {
//         if (show_val_display) {
//             cout<<"Record\tCount\tScaled"<<endl;
//             for (int i = 0 ; i<nb_data;++i) {
//                 cout<<i<<endl;
//                 for (int j=0;j<MAX_PARASOL_DIRECTION;++j)
//                     cout<<"\t"<<j<<"\t"<<(int)count_data[i*MAX_PARASOL_DIRECTION+j]<<"\t"<<scaled_data[i*MAX_PARASOL_DIRECTION+j]<<endl;
//                 cout<<endl;
//             }
//         }
//     }
//     delete[] count_data;
//     count_data=NULL;
//     delete[] scaled_data;
//     scaled_data=NULL;

    return 0;
}
